# Question System

If we refer to *question* we actually mean just some text that is a task, e.g. the exercise task

[The real reason for that is that there was a survey feature planned and a survey has questions and we only wanted 1 parser for the question syntax and the exercise task syntax and the question syntax was *bigger*
We never changed the name of the files... TOOD??]

The `XXXGuide` files are guides to the specific syntax for some texts, currently there are

- `frontend/src/questionSystem/exerciseQuestionSyntaxGuide.md` which describes the syntax of the exercise tasks
- `frontend/src/questionSystem/testSyntaxGuide.md` which describes the syntax of the tests


The file `frontend/src/questionSystem/surveySyntaxParser.ts` contains the parser for the exercise question [truly bad written and not in immutable style!! but works for now...]

For the test syntax there is a *parser* function for the test syntax in `frontend/src/helpers/convertersAndTransformers.ts > convertTestProtocol` [TODO maybe cleanup and move the question syntax parser inside the helpers and let the folder for guides??]

## Modified markdown parser

Because we want the exercise task to handle multiple variants (e.g. markdown/pdf/plain text) one need to specify that

For markdown we want *Latex-Math* code which is a bit tricky because `x_2 + y_2` is valid *latex* but markdown interpret the `_ ... _` as italic code

This is the reason why we needed to modify the `marked` parser a bit ...


## Assets (images, ...)

Another thing to note is that we can't use regular links for e.g. images (because they are stored as blobs in the db and not as a file) so there is no link for an image
The solution is to use a pattern `asset://[name]` so be able to reference an image
The pattern is then resolved if the image from the server is received and a blob is created which has a local url

## Code block languages

There are some code block langs supported for highlighting, see [adding markdown lang](../tutorials/addingMarkdownLang.md) which are supported and how to add one

## JsScripts

Because html is allowed in the markdown (e.g. to enable images) one could try to include a js script (to do some bad things...)

The last test indicated that react filters this somehow (i guess because we use `dangerouslySetInnerHTML`)
