# Adding a markdown code language

The supported markdown code languages can be added/removed inside the `frontend/src/setup.ts` file.

Just require the needed language inside highlight.js

```ts
const json = require('highlight.js/lib/languages/json')
```

(for all languages see `node_modules/highlight.js/lib/languages/)

and register it

```ts
hljs.registerLanguage('json', json)
```

Now code blocks in exercise descriptions will highlight json code blocks

a code block in markdown is produced with \`\`\` then the lang shortcut, then
the code and closed with \`\`\` e.g.

\`\`\`json
{...}
\`\`\`


